#
# Copyright (c) 2023, HILSTER - https://hilster.io
# All rights reserved.
#

from typing import Any

from oser.core import Constant as _Constant
from oser.types import OserScalarType


def Constant(*args: OserScalarType, **kwargs: Any) -> OserScalarType:  # noqa: N802: this is intended
    """
    Wrapper to make any OSER type or class a constant.

    Args:
        *args (tuple): the first positional argument is the class that will be made constant. All other parameters are
            passed to the __init__ of the first positional argument.
        **kwargs: keyword parameters are passed to the __init__ of the first positional argument.
    """
    return _Constant(*args, **kwargs)
