#
# Copyright (c) 2023, HILSTER - https://hilster.io
# All rights reserved.
#

from typing import Union, Callable, Optional

from oser.core import RegularExpressionMatch as _RegularExpressionMatch, String


def RegularExpressionMatch(  # noqa: N802: this is intended
    pattern: Union[str, bytes],
    length: Optional[Union[Callable, int]] = None,  # noqa: N802: this is intended
    value: Union[bytes, str] = b"",
    padding: Union[bytes, str] = b"\x00",
) -> String:
    """
    ``RegularExpressionMatch`` creates a :py:class:`oser.String` matches a regular expression.

    Args:
        pattern: a regular expression pattern.
        length: the length of the underlying string.
        value="": the initial value.
        padding=b"\x00": padding character for the string when it is encoded.
    """
    return _RegularExpressionMatch(pattern=pattern, length=length, value=value, padding=padding)  # type: ignore
